package dev.shadowsoffire.apotheosis.spawn.modifiers;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerModifier;
import dev.shadowsoffire.apotheosis.spawn.modifiers.StatModifier;
import java.util.ArrayList;
import java.util.List;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.world.item.crafting.RecipeSerializer;

public class Serializer implements RecipeSerializer<SpawnerModifier> {
  public SpawnerModifier fromJson(ResourceLocation id, JsonObject obj) {
    Ingredient mainhand = Ingredient.m_43917_(obj.get("mainhand"));
    Ingredient offhand = obj.has("offhand") ? Ingredient.m_43917_(obj.get("offhand")) : Ingredient.f_43901_;
    JsonArray stats = obj.get("stat_changes").getAsJsonArray();
    List<StatModifier<?>> statChanges = new ArrayList<>();
    for (JsonElement e : stats)
      statChanges.add(StatModifier.parse(e.getAsJsonObject())); 
    return new SpawnerModifier(id, mainhand, offhand, (offhand == Ingredient.f_43901_) ? false : obj.get("consumes_offhand").getAsBoolean(), statChanges);
  }
  
  public SpawnerModifier fromNetwork(ResourceLocation id, FriendlyByteBuf buf) {
    Ingredient mainhand = Ingredient.m_43940_(buf);
    Ingredient offhand = buf.readBoolean() ? Ingredient.m_43940_(buf) : Ingredient.f_43901_;
    boolean consumesOffhand = buf.readBoolean();
    List<StatModifier<?>> statChanges = new ArrayList<>();
    int size = buf.readByte();
    for (int i = 0; i < size; i++)
      statChanges.add(StatModifier.read(buf)); 
    return new SpawnerModifier(id, mainhand, offhand, consumesOffhand, statChanges);
  }
  
  public void toNetwork(FriendlyByteBuf buf, SpawnerModifier recipe) {
    recipe.mainHand.m_43923_(buf);
    buf.writeBoolean((recipe.offHand != Ingredient.f_43901_));
    if (recipe.offHand != Ingredient.f_43901_)
      recipe.offHand.m_43923_(buf); 
    buf.writeBoolean(recipe.consumesOffhand);
    buf.writeByte(recipe.statChanges.size());
    recipe.statChanges.forEach(m -> m.write(buf));
  }
}
